//==========================================================================================================
//This set of functions will access the file system and write the results of the current lead configurations
//==========================================================================================================
function getFileSystem(){
    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, gotFS, fail);
}
function gotFS(fileSystem) {
    fileSystem.root.getFile(document.getElementById("patientID").value.replace(/ /g, "_").replace(/\//g, "_").replace(/:/g, "_").replace(/\./g, "_")+"_"+document.getElementById("date").value.replace(/ /g, "_").replace(/\//g, "_").replace(/:/g, "_").replace(/\./g, "_")+"_"+document.getElementById("time").value.replace(/ /g, "_").replace(/\//g, "_").replace(/:/g, "_").replace(/\./g, "_")+".txt", {create: true, exclusive: false}, gotFileEntry, fail);
}
function gotFileEntry(fileEntry) {
    fileEntry.createWriter(gotFileWriter, fail);
}
function gotFileWriter(writer) {
    alert("File Created");
    var array = [parseInt(document.getElementById("C_0a").value), parseInt(document.getElementById("C_1a").value), parseInt(document.getElementById("C_2a").value), parseInt(document.getElementById("C_3a").value), parseInt(document.getElementById("0_1a").value), parseInt(document.getElementById("0_2a").value), parseInt(document.getElementById("0_3a").value), parseInt(document.getElementById("1_2a").value), parseInt(document.getElementById("1_3a").value), parseInt(document.getElementById("2_3a").value), parseInt(document.getElementById("C_8a").value), parseInt(document.getElementById("C_9a").value), parseInt(document.getElementById("C_10a").value), parseInt(document.getElementById("C_11a").value), parseInt(document.getElementById("8_9a").value), parseInt(document.getElementById("8_10a").value), parseInt(document.getElementById("8_11a").value), parseInt(document.getElementById("9_10a").value), parseInt(document.getElementById("9_11a").value), parseInt(document.getElementById("10_11a").value)];
    var array1 = [parseInt(document.getElementById("C_0b").value), parseInt(document.getElementById("C_1b").value), parseInt(document.getElementById("C_2b").value), parseInt(document.getElementById("C_3b").value), parseInt(document.getElementById("0_1b").value), parseInt(document.getElementById("0_2b").value), parseInt(document.getElementById("0_3b").value), parseInt(document.getElementById("1_2b").value), parseInt(document.getElementById("1_3b").value), parseInt(document.getElementById("2_3b").value), parseInt(document.getElementById("C_8b").value), parseInt(document.getElementById("C_9b").value), parseInt(document.getElementById("C_10b").value), parseInt(document.getElementById("C_11b").value), parseInt(document.getElementById("8_9b").value), parseInt(document.getElementById("8_10b").value), parseInt(document.getElementById("8_11b").value), parseInt(document.getElementById("9_10b").value), parseInt(document.getElementById("9_11b").value), parseInt(document.getElementById("10_11b").value)];
    var array2 = [parseInt(document.getElementById("C_8b").value), parseInt(document.getElementById("C_9b").value), parseInt(document.getElementById("C_10b").value), parseInt(document.getElementById("C_11b").value), parseInt(document.getElementById("8_9b").value), parseInt(document.getElementById("8_10b").value), parseInt(document.getElementById("8_11b").value), parseInt(document.getElementById("9_10b").value), parseInt(document.getElementById("9_11b").value), parseInt(document.getElementById("10_11b").value), parseInt(document.getElementById("C_0b").value), parseInt(document.getElementById("C_1b").value), parseInt(document.getElementById("C_2b").value), parseInt(document.getElementById("C_3b").value), parseInt(document.getElementById("0_1b").value), parseInt(document.getElementById("0_2b").value), parseInt(document.getElementById("0_3b").value), parseInt(document.getElementById("1_2b").value), parseInt(document.getElementById("1_3b").value), parseInt(document.getElementById("2_3b").value)];
    var cor = Math.round(mathUtils.getPearsonsCorrelation(array, array1)*100)/100;   
    var rev = Math.round(mathUtils.getPearsonsCorrelation(array, array2)*100)/100; 
    writer.write(
    "Patient ID: "+document.getElementById("patientID").value+"\n"+
    "Date: "+document.getElementById("date").value+"\n"+
    "Time: "+document.getElementById("time").value+"\n"+
    "----------\n"+
    "Impedance\n"+
    "----------\n"+
    "Before\n"+
    "----------\n"+
    "C&0: "+document.getElementById("C_0a").value+"\n"+
    "C&1: "+document.getElementById("C_1a").value+"\n"+
    "C&2: "+document.getElementById("C_2a").value+"\n"+
    "C&3: "+document.getElementById("C_3a").value+"\n"+
    "0&1: "+document.getElementById("0_1a").value+"\n"+
    "0&2: "+document.getElementById("0_2a").value+"\n"+
    "0&3: "+document.getElementById("0_3a").value+"\n"+
    "1&2: "+document.getElementById("1_2a").value+"\n"+
    "1&3: "+document.getElementById("1_3a").value+"\n"+
    "2&3: "+document.getElementById("2_3a").value+"\n"+
    "C&8: "+document.getElementById("C_8a").value+"\n"+
    "C&9: "+document.getElementById("C_9a").value+"\n"+
    "C&10: "+document.getElementById("C_10a").value+"\n"+
    "C&11: "+document.getElementById("C_11a").value+"\n"+
    "8&9: "+document.getElementById("8_9a").value+"\n"+
    "8&10: "+document.getElementById("8_10a").value+"\n"+
    "8&11: "+document.getElementById("8_11a").value+"\n"+
    "9&10: "+document.getElementById("9_10a").value+"\n"+
    "9&11: "+document.getElementById("9_11a").value+"\n"+
    "10&11: "+document.getElementById("10_11a").value+"\n"+
    "----------\n"+
    "After\n"+
    "----------\n"+
    "C&0: "+document.getElementById("C_0b").value+"\n"+
    "C&1: "+document.getElementById("C_1b").value+"\n"+
    "C&2: "+document.getElementById("C_2b").value+"\n"+
    "C&3: "+document.getElementById("C_3b").value+"\n"+
    "0&1: "+document.getElementById("0_1b").value+"\n"+
    "0&2: "+document.getElementById("0_2b").value+"\n"+
    "0&3: "+document.getElementById("0_3b").value+"\n"+
    "1&2: "+document.getElementById("1_2b").value+"\n"+
    "1&3: "+document.getElementById("1_3b").value+"\n"+
    "2&3: "+document.getElementById("2_3b").value+"\n"+
    "C&8: "+document.getElementById("C_8b").value+"\n"+
    "C&9: "+document.getElementById("C_9b").value+"\n"+
    "C&10: "+document.getElementById("C_10b").value+"\n"+
    "C&11: "+document.getElementById("C_11b").value+"\n"+
    "8&9: "+document.getElementById("8_9b").value+"\n"+
    "8&10: "+document.getElementById("8_10b").value+"\n"+
    "8&11: "+document.getElementById("8_11b").value+"\n"+
    "9&10: "+document.getElementById("9_10b").value+"\n"+
    "9&11: "+document.getElementById("9_11b").value+"\n"+
    "10&11: "+document.getElementById("10_11b").value+"\n"+
    "----------\n"+
    "Correlation: "+cor+"\n"+
    "Reversed: "+rev);
}   

//==================================================================================================================
//This set of functions will access the file system and display the list of lead configurations that have been saved
//==================================================================================================================
function getFileList() {
    //request the persistent file system
    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, doDirectoryListing, fail);
}
function doDirectoryListing(fileSystem) {
    //get a directory reader from our FS
    var dirReader = fileSystem.root.createReader();
    dirReader.readEntries(gotFiles,fail);	
}
function gotFiles(entries) {
    var ss = "";
    for(var i=0,len=entries.length; i<len; i++) {
        ss = ss.concat("----"+entries[i].name);
    }
    window.location.href="list.html?"+ss;
} 

//===========================================================================================================
//This set of functions will access the file system and display the results of the chosen lead configurations
//===========================================================================================================
function getFileSystem2(){
    window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, doReadFile, fail);
}
function doReadFile(fileSystem) {
    fileSystem.root.getFile(sessionStorage.getItem('fileName'), {create: true, exclusive: false}, gottenFileEntry, fail);
}
function gottenFileEntry(fileEntry) {
    fileEntry.file(gottenFile, fail);
}
function gottenFile(file){
    readAsText(file);
}
function readAsText(file) {
    var reader = new FileReader();
    reader.onloadend = function(evt) {
        alert(evt.target.result);
    };
    reader.readAsText(file);
}

//==========================================================================================================================
//This fail function will be called by either of the last two sets of functions accessing the file system if they are unable
//==========================================================================================================================
function fail(error) {
    //console.log(error.code);
    alert("fail");
}

var mathUtils = {};
mathUtils.getPearsonsCorrelation = function(x, y) {
	var shortestArrayLength = 0;
	if(x.length == y.length)
	{
		shortestArrayLength = x.length;
	}
	else if(x.length > y.length)
	{
		shortestArrayLength = y.length;
		console.error('x has more items in it, the last ' + (x.length - shortestArrayLength) + ' item(s) will be ignored');
	}
	else
	{
		shortestArrayLength = x.length;
		console.error('y has more items in it, the last ' + (y.length - shortestArrayLength) + ' item(s) will be ignored');
	}
	var xy = [];
	var x2 = [];
	var y2 = [];
	for(var i=0; i<shortestArrayLength; i++)
	{
		xy.push(x[i] * y[i]);
		x2.push(x[i] * x[i]);
		y2.push(y[i] * y[i]);
	}
	var sum_x = 0;
	var sum_y = 0;
	var sum_xy = 0;
	var sum_x2 = 0;
	var sum_y2 = 0;
	for(var i=0; i<shortestArrayLength; i++)
	{
		sum_x += x[i];
		sum_y += y[i];
		sum_xy += xy[i];
		sum_x2 += x2[i];
		sum_y2 += y2[i];
	}
	var step1 = (shortestArrayLength * sum_xy) - (sum_x * sum_y);
	var step2 = (shortestArrayLength * sum_x2) - (sum_x * sum_x);
	var step3 = (shortestArrayLength * sum_y2) - (sum_y * sum_y);
	var step4 = Math.sqrt(step2 * step3);
	var answer = step1 / step4;
	return answer;
}

function corr(){
    var array = [parseInt(document.getElementById("C_0a").value), parseInt(document.getElementById("C_1a").value), parseInt(document.getElementById("C_2a").value), parseInt(document.getElementById("C_3a").value), parseInt(document.getElementById("0_1a").value), parseInt(document.getElementById("0_2a").value), parseInt(document.getElementById("0_3a").value), parseInt(document.getElementById("1_2a").value), parseInt(document.getElementById("1_3a").value), parseInt(document.getElementById("2_3a").value), parseInt(document.getElementById("C_8a").value), parseInt(document.getElementById("C_9a").value), parseInt(document.getElementById("C_10a").value), parseInt(document.getElementById("C_11a").value), parseInt(document.getElementById("8_9a").value), parseInt(document.getElementById("8_10a").value), parseInt(document.getElementById("8_11a").value), parseInt(document.getElementById("9_10a").value), parseInt(document.getElementById("9_11a").value), parseInt(document.getElementById("10_11a").value)];
    var array1 = [parseInt(document.getElementById("C_0b").value), parseInt(document.getElementById("C_1b").value), parseInt(document.getElementById("C_2b").value), parseInt(document.getElementById("C_3b").value), parseInt(document.getElementById("0_1b").value), parseInt(document.getElementById("0_2b").value), parseInt(document.getElementById("0_3b").value), parseInt(document.getElementById("1_2b").value), parseInt(document.getElementById("1_3b").value), parseInt(document.getElementById("2_3b").value), parseInt(document.getElementById("C_8b").value), parseInt(document.getElementById("C_9b").value), parseInt(document.getElementById("C_10b").value), parseInt(document.getElementById("C_11b").value), parseInt(document.getElementById("8_9b").value), parseInt(document.getElementById("8_10b").value), parseInt(document.getElementById("8_11b").value), parseInt(document.getElementById("9_10b").value), parseInt(document.getElementById("9_11b").value), parseInt(document.getElementById("10_11b").value)];
    var array2 = [parseInt(document.getElementById("C_8b").value), parseInt(document.getElementById("C_9b").value), parseInt(document.getElementById("C_10b").value), parseInt(document.getElementById("C_11b").value), parseInt(document.getElementById("8_9b").value), parseInt(document.getElementById("8_10b").value), parseInt(document.getElementById("8_11b").value), parseInt(document.getElementById("9_10b").value), parseInt(document.getElementById("9_11b").value), parseInt(document.getElementById("10_11b").value), parseInt(document.getElementById("C_0b").value), parseInt(document.getElementById("C_1b").value), parseInt(document.getElementById("C_2b").value), parseInt(document.getElementById("C_3b").value), parseInt(document.getElementById("0_1b").value), parseInt(document.getElementById("0_2b").value), parseInt(document.getElementById("0_3b").value), parseInt(document.getElementById("1_2b").value), parseInt(document.getElementById("1_3b").value), parseInt(document.getElementById("2_3b").value)];
    var cor = Math.round(mathUtils.getPearsonsCorrelation(array, array1)*100)/100;   
    var rev = Math.round(mathUtils.getPearsonsCorrelation(array, array2)*100)/100; 
    alert("Correlation: "+cor+"\n"+"Reversed: "+rev); 
}

function clearer(){
    $(ff).find('input[type=tel]').val('');
}     
     
function handleLogin() {
    var form = $("#ff");    
    //$("#sub",form).attr("disabled","disabled");
    var e = $("#bx1", form).val();
    var p = $("#bx2", form).val();

    console.log("click");
    if(e != "" && p != "") {
       //var str = form.serialize();
       //alert(str);
       $.ajax({ 
           type: 'POST', 
           url: 'http://mobilehealth-labs.com/DBS/LoginWebService2.php', 
           crossDomain: true,
           data:  {username: e, password :p},
           dataType: 'json', 
           async: false,
           success: function (response){ 
              if (response.success) { 
                  //alert("you're logged in");
                  //window.localStorage["email"] = e;
                  //window.localStorage["password"] = md5(p); 
                  //window.localStorage["UID"] = data.uid;           
                  window.location = "calculator.html";
              }       
              else {

                  alert("Your login failed");
                  window.location = "index.html";
              }
           },
           error: function(error){
               //alert(response.success);
              alert('Could not connect to the database');
              window.location = "index.html";
          }
       }); 
    }
    else {
       //if the email and password is empty
       alert("You must enter username and password");
    }
    return false;
}

function handleReg() {
    var form = $("#reg");    
    //$("#suber",form).attr("disabled","disabled");
    var uname = $("#uname", form).val();
    var pword1 = $("#pword1", form).val();
    var pword2 = $("#pword2", form).val();
    var first = $("#first", form).val();
    var last = $("#last", form).val();
    var email = $("#email", form).val();

    if(uname != "" && pword1 != "" && pword2 != "" && first != "" && last != "" && email != "") {
        if(pword1 == pword2) {
            if(email.split('@')[1]=="rwjms.rutgers.edu" || email.split('@')[1]=="rutgers.edu" || email.split('@')[1]=="umdnj.edu"){
                $.ajax({ 
                    type: 'POST', 
                    url: 'http://mobilehealth-labs.com/DBS/LoginWebService.php', 
                    crossDomain: true,
                    data:  {uname: uname, pword1 :pword1, first :first, last :last, email :email},
                    dataType: 'json', 
                    async: false,

                    success: function (response){ 
                       if (response.success) { 
                           alert("You've successfully registered");
                           //window.localStorage["email"] = e;
                           //window.localStorage["password"] = md5(p); 
                           //window.localStorage["UID"] = data.uid;           
                           window.location = "index.html";
                       } 
                       else {
                           alert("Registration failed");
                           //window.location("main.html");
                       }
                    },
                    error: function(error){
                        //alert(response.success);
                       alert('Could not connect to the database' + error);
                       window.location = "index.html";
                   }
                });
            }
            else{
                alert("You do not have an institutional subscription. Email us at info@mobilehealth-labs.com for more information.");
            }
        }
        else{
            alert("Passwords don't match");
        }
    }
    else {
        //if the email and password is empty
        alert("Missing data");
    }
    return false;
}        